<?php

if (constant('BRUTAL_CACHE_INSIDE') !== 'SAW_INSIDE' ) { die('No Access'); }

//Cache_delete was pressed
if (isset($_POST['brutal_cache_cache_loeschen'])) {
    $this->delete_cache();
    $notice .= 'Cache deleted';
}

if (isset($_POST['brutal_cache_onefile_cache_loeschen'])) {
    $this->delete_cache($_POST['brutal_cache_onefile']);
    $notice .= 'Cachefile deleted';
}

//Create new config
if (isset($_POST['brutal_cache_change_config'])) {
    if ( isset( $_POST['brutal_cache_timeval_active'] ) ) {
        $this->config['timeval_active'] = ($_POST['brutal_cache_timeval_active'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['timeval_active'] = 0;
    }

    if ( isset( $_POST['brutal_cache_timeval_time'] ) ) {
        $this->config['timeval_time'] = ( intval( $_POST['brutal_cache_timeval_time'] ) * 60 );
    } else {
        $this->config['timeval_time'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_use_user_stored'] ) ) {
        $this->config['use_user_stored'] = ($_POST['brutal_cache_use_user_stored'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['use_user_stored'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_delete_by_admin_call'] ) ) {
        $this->config['delete_by_admin_call'] = ($_POST['brutal_cache_delete_by_admin_call'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['delete_by_admin_call'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_minify_cache'] ) ) {
        $this->config['minify_cache'] = ($_POST['brutal_cache_minify_cache'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['minify_cache'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_reduce_http'] ) ) {
        $this->config['reduce_http'] = ($_POST['brutal_cache_reduce_http'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['reduce_http'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_hook_prioritat'] ) && intval( $_POST['brutal_cache_hook_prioritat'] ) > 0 && intval( $_POST['brutal_cache_hook_prioritat'] ) < 21 ) {
        $this->config['hook_prioritat'] = intval($_POST['brutal_cache_hook_prioritat']);
    } else {
        $this->config['hook_prioritat'] = 1 ;
    }

    if ( isset( $_POST['brutal_cache_hook_event'] ) ) {

        switch ( $_POST['brutal_cache_hook_event'] ) {
            case 'plugins_loaded':
                $this->config['hook_event'] = 1 ;
                break;
            case 'sanitize_comment_cookies':
                $this->config['hook_event'] = 2 ;
                break;
            case 'setup_theme':
                $this->config['hook_event'] = 3 ;
                break;
            default:
                $this->config['hook_event'] = 1 ;
        }

    }

    $this->save_config_to_file();
}

if ( isset( $_POST['brutal_cache_brutal_mode_change'] ) ) {
    if ( $this->config['brutal_mode'] == 0 ) {
        if ( $this->activate_brutal_mode() ) {
            $this->config['brutal_mode'] = 1 ;
            $notice = 'Brutal Mode activated.';
        }
    } else {
        if ( $this->deactivate_brutal_mode() ) {
            $this->config['brutal_mode'] = 0 ;
            $notice = 'Brutal Mode deactivated.';
        }
    }
    if ( $notice === false ) {
        $notice = 'Can\'t change Brutal Mode state.';
    }
    $this->save_config_to_file();
}

//create output design
echo '<div class="wrap" style="border:1px; margin: 10px 10px 10px 10px;">';
if ($notice !== false) {
    echo '<dir style="border: solid 1px; width:100%; margin: 10px 10px 10px 10px;">'.$notice.'</dir>';
}

echo '<h2> Brutal Cache Configuration </h2>'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     '<br /><h3>Mainconfiguration</h3><br />';

echo '<b>Should the cache be actualisized after a sertaind time? </b>';
if ($this->config['timeval_active'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_timeval_active" />'.
         '<br /> If this function is deactivated, the cache will be created one time, but only this time.'.
         'If it\'s activated the cache will be generated new after a sertain time.'.
         'Good is that the content is new after a sertain time, but to short intervals will destroy the caching'.
         'effect.'.
         '<br /><br />'.
         '<b>Interval for creating new cache: </b>'.
         '<input type="text" value="'.( $this->config['timeval_time'] / 60 ).'" name="brutal_cache_timeval_time" />'.
         '<br /> This option is important. This configuration says the time interval between the points of creating'.
         'cache new. Remember: it\' given in minuites';
} else {
    echo '<input type="checkbox" name="brutal_cache_timeval_active" />'.
         '<br /> If this function is deactivated, the cache will be created one time, but only this time.'.
         'If it\'s activated the cache will be generated new after a sertain time.'.
         'Good is that the content is new after a sertain time, but to short intervals will destroy the caching'.
         'effect.';
}

echo '<br /><br />'.
     '<b>Should visitor\'s cache be used? </b>';

if ($this->config['use_user_stored'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_use_user_stored" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_use_user_stored" />';
}

echo '<br />This option will test, wheather the user has the cache in the client or not. It will save  '.
     'your traffic and speed your page up.'.
     '<br /><br />'.
     '<b>Delete cache by calling Admin panel </b>';

if ($this->config['delete_by_admin_call'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_delete_by_admin_call" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_delete_by_admin_call" />';
}

echo '<br />If this option is activated, the cache will be deleted every call of the admin panel.'.
     'The advantage is, that the posts are every time up to date. But the disadvantage is, that the admin '.
     'panel speed will slow down.'.
     '<br /><br />'.
     '<b>Minify cache?</b>';

//cache minifing
if ($this->config['minify_cache'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_minify_cache" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_minify_cache" />';
}

echo '<br />If this option is active the cachefiles will be minified, so it saves traffic.'.
     '<br /><br />'.
     '<b>Reduce HTTP-requests</b>';

if ($this->config['reduce_http'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_reduce_http" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_reduce_http" />';
}

echo '<br />With this option included CSS and JS files will be checked and get involved into the cachefile. '.
    'With this HTTP-requests could be reduced. "allow_url_fopen" has to be activated in the php.ini, otherwise '.
    'it wouldn\'t work.'.
    '<br /><br />'.
    '<h3>Expert configuration</h3>'.
    '<b>At which event should be hooked?</b>';

echo '<select name="brutal_cache_hook_event">';
switch ($this->config['hook_event']) {
    case 1:
        echo '<option selected="selected">plugins_loaded</option>'.
            '<option>sanitize_comment_cookies</option>'.
            '<option>setup_theme</option>';
        break;
    case 2:
        echo '<option>plugins_loaded</option>'.
             '<option selected="selected">sanitize_comment_cookies</option>'.
             '<option>setup_theme</option>';
        break;
    case 3:
        echo '<option>plugins_loaded</option>'.
             '<option>sanitize_comment_cookies</option>'.
             '<option selected="selected">setup_theme</option>';
        break;
    default:
        echo '<option selected="selected">plugins_loaded</option>'.
             '<option>sanitize_comment_cookies</option>'.
             '<option>setup_theme</option>';
}
echo '</select>'.
     '<br />Here you can decide when the plugin will be hooked. This is important to arrange with other plugins. '.
     'The higher the option, earlier the plugin will be executed. This configuration is only important, if you '.
     'know what you are doing! <br />The brutal mode will ignore this!';

echo '<br /><br />'.
     '<b>Which priority should brutal cache gain? </b>'.
     '<input type="text" value="'.$this->config['hook_prioritat'].'" maxlength="2" size="2" name="brutal_cache_hook_prioritat" /><br />'.
     'The priority can take a value between 1 and 20. The priority gives the priority at the hook itself.'.
     '1 is the earliest, 20 the last. This can be useful to ajust the caching to the other plugins.<br />'.
     'The brutal mode will ignore this!';


echo '<br /><br />'.
     '<input type="submit" value="Save" name="brutal_cache_change_config" />'.
     '</form>';

echo '<br /><br /><h3>Delete Cache</h3><br />'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     'Here the cache can be deleted manualy.'.
     '<br /><br />'.
     '<input type="submit" value="Delete cache" name="brutal_cache_cache_loeschen" />'.
     '</form>';

echo '<br />'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     'Here you could delete single cachefiles.<br />'.
     '<select name="brutal_cache_onefile">';

     $h = scandir( $this->BRUTAL_CACHE_DIR.'/cache/' );
       foreach( $h as $f ) {
            if ( $f != '.' && $f != '..' && $f != 'index.php' ) {
                echo '<option>'.$f.'</option>';
            }
        }
     unset($f,$h);

echo '</select>'.
     '<input type="submit" value="Delete cachefile" name="brutal_cache_onefile_cache_loeschen" />'.
     '</form>';

echo '<br /><br /><h3>Brutal Mode</h3><br />'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     'IMPORTANT! This makes your blog nearly complete static. Be sure, that you want this. The speed is great, '.
     'but remember that WordPress wouldn\' be executed.'.
     'This mode is useful, but be sure that you need it. It\'s not useful for each user.'.
     'But be not afraid of testing it, deactivating is as easy as activating.'.
     '<br /><br />';

if ($this->config['brutal_mode'] == 0) {
    echo '<input type="submit" value="Brutal Mode activate" name="brutal_cache_brutal_mode_change" />';
} else {
    echo '<input type="submit" value="Brutal Mode deactivate" name="brutal_cache_brutal_mode_change" />';
}

echo '</form>'.
     '<br /><br />'.
     '</div>';

?>